import TextareaAutosize from "react-autosize-textarea";
import * as React_$1 from "react";
import * as React_$2 from "react";
declare type TextAreaProps = Omit<TextareaAutosize.Props, 'onChange'>;
interface EditorProps extends TextAreaProps {
    defaultValue?: string;
    disableFormatting?: boolean;
    singleLine?: boolean;
    onChange?(value: string): void;
    onSubmit?(): void;
    onBlur?(): void;
    onCancel?(): void;
}
interface EditorData {
    currentWord: string;
    value: string;
    valueUpToStart: string;
    lastSelectionStart: number;
}
interface State {
    editor: EditorData;
    width: number;
    height: number;
}
declare type EditorDataAction = {
    type: 'EditorData';
    payload: HTMLTextAreaElement;
};
declare type EditorSizeAction = {
    type: 'EditorSize';
    payload: {
        width: number;
        height: number;
    };
};
declare type TabAction = {
    type: 'AddTab';
    payload: HTMLTextAreaElement;
};
declare type ListItemAction = {
    type: 'AddListItem';
    payload: {
        el: HTMLTextAreaElement;
        type: 'ul' | 'ol';
    };
};
declare type ClearListAction = {
    type: 'ClearList';
    payload: HTMLTextAreaElement;
};
declare type BoldAction = {
    type: 'ToggleBold';
    payload: HTMLTextAreaElement;
};
declare type ItalicAction = {
    type: 'ToggleItalic';
    payload: HTMLTextAreaElement;
};
declare type EncloseAction = {
    type: 'Enclose';
    payload: {
        el: HTMLTextAreaElement;
        type: '[' | '(' | '{';
    };
};
declare type Action = EditorDataAction | EditorSizeAction | TabAction | ListItemAction | ClearListAction | BoldAction | ItalicAction | EncloseAction;
interface EditorContextValues {
    state: State;
    dispatch(action: Action): void;
    editorRef: React_$1.RefObject<HTMLTextAreaElement | null>;
}
declare const EditorContet: React_$1.Context<EditorContextValues | undefined>;
declare const Editor: React_$1.FC<EditorProps>;
interface MentionData {
    value: string | number;
    label: string;
}
interface MarkdownMentionProps {
    prefix: string;
    data: MentionData[];
    onSearch?(value: string): void;
}
declare const Mention: React_$2.FC<MarkdownMentionProps>;
export { EditorContextValues, EditorContet, Editor, Mention };
